package pwc.taxtech.atms.controller;

import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;
import pwc.taxtech.atms.service.IdentityService;
import pwc.taxtech.atms.vat.service.FinanceDataImportService;

@RestController
@RequestMapping("/api/v1/financeImportData")
public class FinanceDataImportController {

    @Autowired
    private FinanceDataImportService financeDataImport;
    @Autowired
    private IdentityService identityService;

    @ApiOperation(value = "")
    @RequestMapping(value = "checkData/basicCheck", method = RequestMethod.GET, produces = MediaType.APPLICATION_JSON_UTF8_VALUE)
    public ResponseEntity getBasicValidationResults() {
        return ResponseEntity.ok().body(financeDataImport.getBasicValidationResults(identityService.getIdentityUser().getID()));
    }

    @RequestMapping(value = "importData/financeDataUpload", method = RequestMethod.POST, produces = MediaType.APPLICATION_JSON_UTF8_VALUE)
    public ResponseEntity FinanceDataUpload() {
//        string importMethod = HttpContext.Current.Request.Params["importMethod"];
//        if (HttpContext.Current.Request.Files.Count == 0)
//        {
//            return this.Ok(new OperationResultDto() { Result = false, ResultMsg = "NoFile" });
//        }
//
//        if (string.IsNullOrEmpty(importMethod))
//        {
//            return this.Ok(new OperationResultDto() { Result = false, ResultMsg = "importMethod is empty" });
//        }
//
//        if (!IsSameFileExtenstion(HttpContext.Current.Request.Files))
//        {
//            return this.Ok(new OperationResultDto() { Result = false, ResultMsg = "file extension is not same" });
//        }
//
//        try
//        {
//            OperationResultDto<ImportDataDto> result = new OperationResultDto<ImportDataDto>();
//            int uploadFileCount = 0;
//            string mappedPath = "";
//            string fileGuid = Guid.NewGuid().ToString().ToUpper();
//            var firstUploadFile = HttpContext.Current.Request.Files[0];
//            string fileExtension = firstUploadFile.FileName.Substring(firstUploadFile.FileName.LastIndexOf(".") + 1, firstUploadFile.FileName.Length - firstUploadFile.FileName.LastIndexOf(".") - 1);
//
//            for (int i = 0; i < HttpContext.Current.Request.Files.Count; i++)
//            {
//                var file = HttpContext.Current.Request.Files[i];
//                mappedPath = SetUploadFolderPath(importMethod, fileExtension);
//                var fileFullPath = Path.Combine(mappedPath, fileGuid + "_" + Path.GetFileName(file.FileName));
//                if (SaveFile(file, mappedPath, fileFullPath))
//                {
//                    uploadFileCount++;
//                }
//            }
//
//            if (uploadFileCount == HttpContext.Current.Request.Files.Count)
//            {
//                result.Result = true;
//                result.ResultMsg = string.Empty;
//                result.Data = new ImportDataDto { Guid = fileGuid, Number = uploadFileCount, FileExtension = fileExtension };
//
//            }
//            return Ok(result);
//        }
//        catch (Exception ex)
//        {
//            Dictionary<Guid, string> error = new Dictionary<Guid, string>();
//            error.Add(System.Guid.NewGuid(), ex.StackTrace);
//            OperationResultDto<ImportDataDto> errorResult = new OperationResultDto<ImportDataDto>()
//            {
//                Result = false,
//                ResultMsg = "Upload File error",
//                Errors = error,
//                Data = new ImportDataDto { Guid = string.Empty, Number = 0, FileExtension = string.Empty }
//            };
//
//            return Ok(errorResult);
//        }
        return ResponseEntity.ok().build();

    }


    @RequestMapping(value = "importData/importFinancedata", method = RequestMethod.POST, produces = MediaType.APPLICATION_JSON_UTF8_VALUE)
    public ResponseEntity FinanceImportData() {
//        string userId = _identityService.IdentityUser.ID;
//        string importMethod = HttpContext.Current.Request.Params["importMethod"];
//        string fileName = HttpContext.Current.Request.Params["fileName"];
//        string importTypeStr = HttpContext.Current.Request.Params["importType"];
//        string fileGuid = HttpContext.Current.Request.Params["fileGuid"];
//        string periodStr = HttpContext.Current.Request.Params["period"];
//        string fileExtension = HttpContext.Current.Request.Params["fileExtension"];
//        string strProjectYear = HttpContext.Current.Request.Params["projectYear"];
//            #region 参数为空即返回
//        if (string.IsNullOrEmpty(importMethod))
//        {
//            return this.Ok(new OperationResultDto() { Result = false, ResultMsg = "importMethod is empty" });
//        }
//
//        if (string.IsNullOrEmpty(fileName))
//        {
//            return this.Ok(new OperationResultDto() { Result = false, ResultMsg = "fileName is empty" });
//        }
//
//        if (string.IsNullOrEmpty(importTypeStr))
//        {
//            return this.Ok(new OperationResultDto() { Result = false, ResultMsg = "importType is empty" });
//        }
//
//        if (string.IsNullOrEmpty(fileGuid))
//        {
//            return this.Ok(new OperationResultDto() { Result = false, ResultMsg = "fileGuid is empty" });
//        }
//
//        if (string.IsNullOrEmpty(periodStr))
//        {
//            return this.Ok(new OperationResultDto() { Result = false, ResultMsg = "periodStr is empty" });
//        }
//
//        if (string.IsNullOrEmpty(fileExtension))
//        {
//            return this.Ok(new OperationResultDto() { Result = false, ResultMsg = "fileExtension is empty" });
//        }
//
//            #endregion
//        int importType = int.Parse(importTypeStr);
//        int projectYear = !string.IsNullOrEmpty(strProjectYear) ? int.Parse(strProjectYear) : -1;
//        int period = int.Parse(periodStr);
//        int importFileCount = 0;
//        var mappedPath = SetUploadFolderPath(importMethod, fileExtension);
//        OperationResultDto<List<ImportDataDto>> result = new OperationResultDto<List<ImportDataDto>>();
//        List<ImportDataDto> importResults = new List<ImportDataDto>();
//        List<string> fileList = fileName.Split(',').ToList();
//        List<string> toDeleteFilesPath = new List<string>();
//            #region 导入数据
//
//        if (importType == (int)DataImport.ImportType.Override)
//        {
//            //如果导入文件只有voucher的话，那么就不用删除CustBalance表中当前期间的数据
//            bool isClearCustTb = fileList.Count == 1 && fileList.First().ToLower().StartsWith(VatGlobal.VoucherTbName.ToLower()) ? false : true;
//            //1. 删除TB相关表的数据
//            _financeDataImport.ClearTable(period,isClearCustTb);
//        }
//        //2. 删除ValidationInfo中Erp相关的数据
//        _financeDataImport.DeleteErpValidation();
//
//        //3. 开始导入数据
//        foreach (var f in fileList)
//        {
//            var fileFullPath = Path.Combine(mappedPath, fileGuid + "_" + Path.GetFileName(f));
//            var schemaPath = HostingEnvironment.MapPath("~/Resource");
//            toDeleteFilesPath.Add(fileFullPath);
//            var importResult = _financeDataImport.ImportData(projectYear, importMethod, importType, period, fileFullPath, f, schemaPath, userId);
//            if (importResult.Result)
//            {
//                importFileCount++;
//            }
//            else
//            {
//                importResults.Add(importResult);
//            }
//        }
//
//        if (importFileCount == fileList.Count)
//        {
//            _financeDataImport.UpdateCompanyBalanceNullValue();
//            result.Result = true;
//            result.ResultMsg = string.Empty;
//            result.Data = importResults;
//            toDeleteFilesPath.ForEach(f =>
//                    {
//            if (File.Exists(f))
//            {
//                File.Delete(f);
//                _logger.Log(LogLevel.Info, "成功删除财务数据导入文件:" + f);
//            }
//                });
//
//        }
//        else
//        {
//            result.Result = false;
//            result.Data = importResults;
//            result.ResultMsg = "导入数据出错: " + "\r\n";
//            foreach (var r in importResults)
//            {
//                result.ResultMsg += r.FileName + "\r\n";
//            }
//        }
//
//            #endregion
//
//        return Ok(result);
        return ResponseEntity.ok().build();

    }
}
